'use strict';

exports.__esModule = true;
exports.isSandbox = exports.isRule = exports.isPurpose = exports.isPerimeter = exports.isGoverness = exports.sandbox = exports.guard = exports.createSandbox = exports.createRule = exports.createPerimeter = exports.WrongRuleDefinition = exports.VERSION = exports.StrictGoverness = exports.Sandbox = exports.Rule = exports.RestrictedMethodError = exports.Purpose = exports.PubSub = exports.Perimeter = exports.NoSandboxError = exports.NoPurposeError = exports.NoGovernessError = exports.NoExposedMethodError = exports.MiddlewareGoverness = exports.Logger = exports.HeadGoverness = exports.GermanGoverness = exports.EasyGoverness = exports.BaseObject = exports.ArgumentError = exports.AccessDenied = undefined;

var _kindergarten = require('./kindergarten');

/**
 * Main namespace is exported by default to keep Kindergarten compatible with
 * versions < 1.0 and for programmers that like to use the classes through the
 * namespace.
 */
var Kindergarten = {
  AccessDenied: _kindergarten.AccessDenied,
  ArgumentError: _kindergarten.ArgumentError,
  BaseObject: _kindergarten.BaseObject,
  EasyGoverness: _kindergarten.EasyGoverness,
  GermanGoverness: _kindergarten.GermanGoverness,
  HeadGoverness: _kindergarten.HeadGoverness,
  isGoverness: _kindergarten.isGoverness,
  isPerimeter: _kindergarten.isPerimeter,
  isPurpose: _kindergarten.isPurpose,
  isRule: _kindergarten.isRule,
  isSandbox: _kindergarten.isSandbox,
  Logger: _kindergarten.Logger,
  MiddlewareGoverness: _kindergarten.MiddlewareGoverness,
  NoExposedMethodError: _kindergarten.NoExposedMethodError,
  NoGovernessError: _kindergarten.NoGovernessError,
  NoPurposeError: _kindergarten.NoPurposeError,
  NoSandboxError: _kindergarten.NoSandboxError,
  Perimeter: _kindergarten.Perimeter,
  PubSub: _kindergarten.PubSub,
  Purpose: _kindergarten.Purpose,
  RestrictedMethodError: _kindergarten.RestrictedMethodError,
  Rule: _kindergarten.Rule,
  Sandbox: _kindergarten.Sandbox,
  StrictGoverness: _kindergarten.StrictGoverness,
  VERSION: _kindergarten.VERSION,
  WrongRuleDefinition: _kindergarten.WrongRuleDefinition,
  guard: _kindergarten.guard,
  sandbox: _kindergarten.sandbox,
  createPerimeter: _kindergarten.createPerimeter,
  createRule: _kindergarten.createRule,
  createSandbox: _kindergarten.createSandbox
};

exports.default = Kindergarten;
exports.AccessDenied = _kindergarten.AccessDenied;
exports.ArgumentError = _kindergarten.ArgumentError;
exports.BaseObject = _kindergarten.BaseObject;
exports.EasyGoverness = _kindergarten.EasyGoverness;
exports.GermanGoverness = _kindergarten.GermanGoverness;
exports.HeadGoverness = _kindergarten.HeadGoverness;
exports.Logger = _kindergarten.Logger;
exports.MiddlewareGoverness = _kindergarten.MiddlewareGoverness;
exports.NoExposedMethodError = _kindergarten.NoExposedMethodError;
exports.NoGovernessError = _kindergarten.NoGovernessError;
exports.NoPurposeError = _kindergarten.NoPurposeError;
exports.NoSandboxError = _kindergarten.NoSandboxError;
exports.Perimeter = _kindergarten.Perimeter;
exports.PubSub = _kindergarten.PubSub;
exports.Purpose = _kindergarten.Purpose;
exports.RestrictedMethodError = _kindergarten.RestrictedMethodError;
exports.Rule = _kindergarten.Rule;
exports.Sandbox = _kindergarten.Sandbox;
exports.StrictGoverness = _kindergarten.StrictGoverness;
exports.VERSION = _kindergarten.VERSION;
exports.WrongRuleDefinition = _kindergarten.WrongRuleDefinition;
exports.createPerimeter = _kindergarten.createPerimeter;
exports.createRule = _kindergarten.createRule;
exports.createSandbox = _kindergarten.createSandbox;
exports.guard = _kindergarten.guard;
exports.sandbox = _kindergarten.sandbox;
exports.isGoverness = _kindergarten.isGoverness;
exports.isPerimeter = _kindergarten.isPerimeter;
exports.isPurpose = _kindergarten.isPurpose;
exports.isRule = _kindergarten.isRule;
exports.isSandbox = _kindergarten.isSandbox;